<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/sys/menu">菜单管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
      <el-form-item label="菜单名称" prop="menuName">
        <el-input type="text" size="mini" v-model="queryModel.menuName"></el-input>
      </el-form-item>
      <el-form-item label="菜单类型" prop="menuType">
        <el-select v-model="queryModel.menuType" size="mini">
          <el-option label="后端接口" value="1"></el-option>
          <el-option label="前端页面" value="2"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="上级菜单" prop="parentId">
        <el-select-tree
            size="mini"
            :props="props"
            :options="queryMenuResult"
            v-model="queryModel.parentId"
            height="200"
          ></el-select-tree>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
        >查询</el-button>&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
        >重置</el-button>&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-remove"
        :disabled="multipleSelection.length==0"
        @click="handleBatchDelete"
      >删除选中项</el-button>
    </el-row>
    <div style="min-height:400px;">
    <el-table
      :data="tableData"
      v-loading="loading"
      stripe
      border
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column
        prop="menuName"
        sort-by="menu_name"
        label="菜单名称"
        width="180"
      >
       <template slot-scope="{row}">
         <i :class="row.icon"></i><span v-html="row.menuName"></span>
        </template>
      </el-table-column>
      <el-table-column
        prop="parentName"
        sort-by="parent_id"
        label="上级菜单"
        width="180"
      ></el-table-column>
      <el-table-column prop="sortNo" label="排序号" :sortable="true" width="180"></el-table-column>
      <el-table-column prop="menuType" label="菜单类型" :sortable="true" width="180">
        <template slot-scope="{row}">{{row.menuType == 1 ? "后端接口" : "前端页面"}}</template>
      </el-table-column>
      <el-table-column prop="menuUrl" label="菜单地址" :sortable="true" width="180"></el-table-column>
      <el-table-column prop="createTime" label="创建时间" :sortable="true" width="180"></el-table-column>
      <el-table-column prop="updateTime" label="更新时间" :sortable="true" width="180"></el-table-column>
      <el-table-column label="操作" width="250" fixed="right">
        <template slot-scope="{row}">
          <el-row>
            <el-col :span="12">
          <el-button size="mini" type="text" @click="showSubmenu(row)">下级菜单</el-button>
            </el-col>
            <el-col :span="12">
          <el-button size="mini" type="text" @click="addSubmenu(row)">新增子菜单</el-button>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-button size="mini" type="text" @click="handleEdit(row)">编辑</el-button>
            </el-col>
            <el-col :span="12">
              <el-button size="mini" type="text" @click="handleDelete(row)">删除</el-button>
            </el-col>
          </el-row>
        </template>
      </el-table-column>
    </el-table>
    </div>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
      <menu-detail
        v-if="showDetailModal"
        @close="onDetailModalClose"
        :menuId="menuId"
        :modalTitle="modalTitle"
        :parentMenu="parentMenu"
      ></menu-detail>

  </div>
</template>
<script>
import Constant from "@/constant";
import MenuDetail from "./menu-detail";
import menuApi from "@/api/sys/menu";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style
import SelectTree from "@/components/SelectTree";

export default {
  name: 'SysMenuList',
  data() {
    var self = this;

    return {
      queryModel: {
        menuName: "",
        menuType: "",
        parentId: ""
      },
      mLoading: false,
      modalTitle: "",
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showDetailModal: false,
      menuId: "",
      queryMenuResult: [],
      parentMenu: {},
      props: {
        // 配置项（必选）
        value: "id",
        label: "menuName"
      }
    };
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("parentId", self.queryModel.parentId);
      formData.append("menuName", self.queryModel.menuName);
      formData.append("menuType", self.queryModel.menuType);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      menuApi
        .pageList(formData)
        .then(function(response) {
          self.loading = false;

          var jsonData = response.data;

          if(jsonData.result){
            var pageInfo = jsonData.data;

            self.tableData = pageInfo.data;
            self.totalPages = pageInfo.totalPages;
            self.totalElements = pageInfo.recordsTotal;
          }
          else {
            self.$message({
                message: jsonData.message + "",
                type: "warning"
              });
          }
        })
        .catch(error => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(()=>{
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
      this.queryMenu();
    },
    handleAdd() {
      var self = this;

      self.modalTitle = "新增";
      self.menuId = "";
      self.parentMenu = {};
      self.showDetailModal = true;

    },
    handleEdit(record) {
      var self = this;

      self.modalTitle = "编辑";
      self.menuId = record.id;
      self.parentMenu = {};
      self.showDetailModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
        .then(() => {
          menuApi.remove(record.id).then(function(response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map(record => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        menuApi.batchRemove(idList).then(function(response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!"
            });
          }
        });
      });
    },   
    onDetailModalClose(refreshed){
      this.showDetailModal = false;

      if(refreshed){
        this.changePage(this.pageIndex);
      }
    },
    queryMenu(keywords) {
      var formData = new FormData();
      formData.append("keywords",keywords);
      formData.append("limit",1000);

      return menuApi.query(formData).then(response=>{
        var jsonData = response.data;

        if(jsonData.result){
          this.queryMenuResult = jsonData.data;
        }
        else{
          this.$message.error(jsonData.message + "");
        }
      });
    },
    showSubmenu(row){
        this.queryMenuResult.length=0; //清空
        this.queryMenuResult.push(row);

        this.queryModel.menuName = "";
        this.queryModel.parentId = row.id;
        this.changePage(1);
    },
    addSubmenu(row){
      var self = this;

      self.modalTitle = "新增";
      self.menuId = "";
      self.parentMenu = row;
      self.showDetailModal = true;
    }
  },
  mounted: function() {
    this.changePage(1);
    this.queryMenu("");
  },
  components: {
    "menu-detail": MenuDetail,
    "el-select-tree": SelectTree
  }
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  padding: 10px;
  text-align: left;
}
</style>